/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.00 11 Mar 1997
 * @author Cay Horstmann
 */

import corejava.*;
import java.math.*;

public class BigIntegerTest
{  public static BigInteger lotteryOdds(int high, int number)
   {  BigInteger r = new BigInteger("1");
      int i;
      for (i = 1; i <= number; i++)
      {  r = r.multiply(BigInteger.valueOf(high))
            .divide(BigInteger.valueOf(i));
         high--;
      }
      return r;
   }

   public static void main(String[] args)
   {  int numbers = Console.readInt
      ("How many numbers do you need to draw?");
      int topNumber = Console.readInt
         ("What is the highest number you can draw?");
      BigInteger oddsAre = lotteryOdds(topNumber, numbers);

      System.out.println("Your odds are 1 in " + oddsAre + 
        ". Good luck!");
   }
}
