/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.10 25 Mar 1997
 * @author Cay Horstmann
 */

import java.awt.*;
import java.awt.image.*;
import java.net.*;
import corejava.*;

public class Image1 extends CloseableFrame
{  public Image1()
   {  image = Toolkit.getDefaultToolkit().getImage
         ("blue-ball.gif");
   }
   
   public void paint(Graphics g)
   {  Dimension d = getSize();
      Insets in = getInsets();
      g.translate(in.left, in.top);
      int clientWidth = d.width - in.right - in.left;
      int clientHeight = d.height - in.bottom - in.top;
   
      int imageWidth = image.getWidth(this);
      int imageHeight = image.getHeight(this);
      
      g.drawImage(image, 0, 0, this);
      for (int i = 0; i <= clientWidth / imageWidth; i++)
        for (int j = 0; 
               j <= clientHeight / imageHeight; j++)
            if (i + j > 0) 
               g.copyArea(0, 0, imageWidth, imageHeight,
                   i * imageWidth, j * imageHeight);
   }
   
   public static void main(String args[])
   {  Frame f = new Image1();
      f.show();
   }
   
   private Image image;
}





