/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.10 27 Apr 1997
 * @author Cay Horstmann
 */

import java.awt.*;
import java.awt.event.*;
import corejava.*;

public class PanelTest extends CloseableFrame 
   implements ActionListener
{  public PanelTest()
   {  Panel p = new Panel();

      Button yellowButton = new Button("Yellow");
      p.add(yellowButton);
      yellowButton.addActionListener(this); 
   
      Button blueButton = new Button("Blue");
      p.add(blueButton);
      blueButton.addActionListener(this); 

      Button redButton = new Button("Red");
      p.add(redButton);
      redButton.addActionListener(this); 

      add(p, "North");
   }
   
   public void actionPerformed(ActionEvent evt)
   {  String arg = evt.getActionCommand();
      Color color = Color.black;
      if (arg.equals("Yellow")) color = Color.yellow;
      else if (arg.equals("Blue")) color = Color.blue;
      else if (arg.equals("Red")) color = Color.red;
      setBackground(color);
      repaint();
   }
   
   public static void main(String[] args)
   {  Frame f = new PanelTest();
      f.show();
   }
}
