/*
 * Cay S. Horstmann & Gary Cornell, Core Java
 * Published By Sun Microsystems Press/Prentice-Hall
 * Copyright (C) 1997 Sun Microsystems Inc.
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this 
 * software and its documentation for NON-COMMERCIAL purposes
 * and without fee is hereby granted provided that this 
 * copyright notice appears in all copies. 
 * 
 * THE AUTHORS AND PUBLISHER MAKE NO REPRESENTATIONS OR 
 * WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE, EITHER 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE AUTHORS
 * AND PUBLISHER SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED 
 * BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING 
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
 
/**
 * @version 1.00 05 Sep 1997
 * @author Gary Cornell
 */

import java.io.*;

public class FindDirectories
{  public static void main(String args[])
   {  if (args.length == 0) args = new String[] { ".." };

      try
      {  File pathName = new File(args[0]);
         String[] fileNames = pathName.list();

         for (int i = 0; i<fileNames.length; i++)
         {  File tf = new File(pathName.getPath(), 
               fileNames[i]);
            if (tf.isDirectory())
            {  System.out.println(tf.getCanonicalPath());
               main(new String [] { tf.getPath() });
            }
         }
      }
      catch(IOException e)
      {  System.out.println("Error: " + e);
      }
   }
}


